clear all 
cap mkdir d:/event/
cd d:/event/
cntrade 300, index 
keep date rmt 
sort date 
save HS300,replace 
postfile abr stk date abr1 abr2 abr3 abr4 abr5 abr6 ///
         abr7 abr8 abr9 abr10 abr11 abr12 abr13 abr14 ///
		 using abr.dta, replace 
clear
input stkcd str10 date
2 "2014-04-14"
600900 "2015-04-14"
28 "2015-04-19"
600000 "2016-04-18"
601898 "2013-08-14"
601988 "2012-12-14"
601666 "2011-06-14"
end
gen temp = date(date,"YMD")
drop date 
rename temp date  
format date %dCY-N-D
mkmat stkcd date,mat(event)
mat list event 
local N=_N
drop _all
forvalue i = 1(1) `N' {
local stk = event[`i',1]
local date = event[`i',2]
cntrade `stk'
keep date rit 
sort date 
merge date using HS300, nokeep 
drop _m 

preserve 
keep if date<`date'
gsort -date
gen time = -_n
keep if time>=-200
save before, replace 
restore 
keep if date>=`date'
gsort date
gen time = _n-1
keep if time<=10
append using before
qui reg rit rmt if time<=-10
predict abr if time>=-3, res 
drop if time<=-4
sort time 
post abr (`stk') (`date') (abr[1]) (abr[2]) ///
         (abr[3]) (abr[4]) (abr[5]) (abr[6]) ///
		 (abr[7]) (abr[8]) (abr[9]) (abr[10]) ///
		 (abr[11]) (abr[12]) (abr[13]) (abr[14]) 
}
postclose abr
use abr, clear
